Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/DirtyList.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/DirtyList.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/DirtyList.cs	(revision 14777)
@@ -0,0 +1,163 @@
+﻿using System;
+using System.Collections.Generic;
+
+namespace TestPooling.DirtyList {
+  using System.Collections;
+
+  [Serializable]
+  public class DirtyList<T> : IList<T>, IReadOnlyList<T> {
+    private readonly List<T> data;
+    private int topIndex;
+
+    public DirtyList(int capacity = 0) {
+      data = new List<T>(capacity);
+    }
+
+    public IEnumerator<T> GetEnumerator() {
+      return data.GetEnumerator();
+    }
+
+    IEnumerator IEnumerable.GetEnumerator() {
+      return GetEnumerator();
+    }
+
+    public void Add(T item) {
+      if (topIndex == data.Count) {
+        data.Add(item);
+      } else {
+        data[topIndex] = item;
+      }
+
+      topIndex++;
+    }
+
+    public void AddRange(IEnumerable<T> items) {
+      foreach (var item in items) {
+        Add(item);
+      }
+    }
+
+    public void RemoveRange(IEnumerable<T> items) {
+      foreach (var item in items) {
+        Remove(item);
+      }
+    }
+
+    public void Clear() {
+      topIndex = 0;
+    }
+
+    public bool Contains(T item) {
+      if (item == null) {
+        for (int i = 0; i < topIndex; i++)
+          if (data[i] == null)
+            return true;
+        return false;
+      } else {
+        var c = EqualityComparer<T>.Default;
+
+        for (int i = 0; i < topIndex; i++) {
+          if (c.Equals(data[i], item)) return true;
+        }
+        return false;
+      }
+    }
+
+    public void CopyTo(T[] array, int arrayIndex) {
+      data.CopyTo(0, array, arrayIndex, topIndex);
+    }
+
+    public bool Remove(T item) {
+      int index = IndexOf(item);
+      if (index >= 0) {
+        RemoveAt(index);
+        topIndex--;
+        return true;
+      }
+
+      return false;
+    }
+
+    int ICollection<T>.Count
+    {
+      get
+      {
+        return topIndex == 0 ? 0 : topIndex - 1;
+      }
+    }
+
+    public bool IsReadOnly
+    {
+      get
+      {
+        return ((ICollection<T>)data).IsReadOnly;
+      }
+    }
+
+    public int IndexOf(T item) {
+      for (var i = 0; i < topIndex; i++) {
+        if (data.Equals(data[i])) return i;
+      }
+
+      return -1;
+    }
+
+    public void Insert(int index, T item) {
+      // Note that insertions at the end are legal.
+      if ((uint)index > (uint)topIndex) {
+        throw new ArgumentOutOfRangeException("index");
+      }
+
+      data.Insert(index, item);
+    }
+
+    public void RemoveAt(int index) {
+      if ((uint)index > (uint)topIndex) {
+        throw new ArgumentOutOfRangeException("index");
+      }
+
+      data.RemoveAt(index);
+      topIndex--;
+    }
+
+    T IList<T>.this[int index]
+    {
+      get
+      {
+        if ((uint)index > (uint)topIndex) {
+          throw new ArgumentOutOfRangeException("index");
+        }
+
+        return data[index];
+      }
+      set
+      {
+        if ((uint)index > (uint)topIndex) {
+          throw new ArgumentOutOfRangeException("index");
+        }
+
+        data[index] = value;
+      }
+    }
+
+    int IReadOnlyCollection<T>.Count
+    {
+      get
+      {
+        return topIndex < 0 ? 0 : topIndex;
+      }
+    }
+
+    T IReadOnlyList<T>.this[int index]
+    {
+      get
+      {
+        if ((uint)index > (uint)topIndex) {
+          throw new ArgumentOutOfRangeException("index");
+        }
+
+        return data[index];
+      }
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushList.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushList.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushList.cs	(revision 14777)
@@ -0,0 +1,41 @@
+﻿using System.Collections.Generic;
+
+namespace TestPooling.DirtyList {
+  public class PushStack2<T> {
+    private readonly List<List<T>> items = new List<List<T>>();
+    private bool IsEnabled { get; set; }
+
+    public PushStack2() {
+      IsEnabled = true;
+    }
+
+    public void Push(T item) {
+      if (!IsEnabled) return;
+
+      this.items[items.Count - 1].Add(item);
+    }
+
+    public void PushRange(IEnumerable<T> items) {
+      if (!IsEnabled) return;
+
+      this.items.Add(new List<T>(items));
+    }
+
+    public T Pop() {
+      var container = items[items.Count - 1];
+
+      if (container.Count == 1) {
+        items.RemoveAt(items.Count - 1);
+      }
+
+      var item = container[container.Count - 1];
+      container.RemoveAt(container.Count - 1);
+
+      return item;
+    }
+
+    public void Clear() {
+      this.items.Clear();
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack.cs	(revision 14777)
@@ -0,0 +1,287 @@
+﻿namespace TestPooling.DirtyList {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  /// <summary>
+  ///     While Push's stacks are generally treated as genuine stacks---that is, inclassions take their arguments from the
+  ///     tops of
+  ///     the stacks and push their results onto the tops of the stacks---a few inclassions (like YANK and SHOVE) do allow
+  ///     direct access
+  ///     to "deep" stack elements by means of integer indices. To this extent the stacks can be used as general, random
+  ///     access memory
+  ///     classures. This is one of the features that ensures the Turing-completeness of Push (another being the arbitrary
+  ///     name/value
+  ///     bindings supported by the NAME data type and DEFINE methods; see below).
+  /// </summary>
+  /// <typeparam name="T">The item type of the collection.</typeparam>
+  public class PushStack<T> {
+    private const string Delimiter = " ";
+
+    private readonly List<T> data;
+
+    public PushStack(int capacity = 0) {
+      this.data = new List<T>(capacity);
+      this.IsEnabled = true;
+    }
+
+    public bool IsEnabled { get; set; }
+
+    public int Capacity
+    {
+      get
+      {
+        return this.data.Capacity;
+      }
+    }
+
+    public T Top
+    {
+      get
+      {
+        return this.data[this.Count - 1];
+      }
+    }
+
+    public T TopOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? this.data[this.Count - 1] : default(T);
+      }
+    }
+
+    public T Bottom
+    {
+      get
+      {
+        return this.data[0];
+      }
+    }
+
+    public T BottomOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? this.data[0] : default(T);
+      }
+    }
+
+    public int Count
+    {
+      get
+      {
+        return this.data.Count;
+      }
+    }
+
+    public bool IsEmpty
+    {
+      get
+      {
+        return this.Count == 0;
+      }
+    }
+
+    public bool IsReadOnly
+    {
+      get
+      {
+        return false;
+      }
+    }
+
+    public void Add(T item) {
+      this.Push(item);
+    }
+
+    public void Clear() {
+      this.data.Clear();
+    }
+
+    public bool Contains(T item) {
+      return this.data.Contains(item);
+    }
+
+    public void CopyTo(T[] array, int arrayIndex) {
+      this.data.CopyTo(array, arrayIndex);
+    }
+
+    public IEnumerator<T> GetEnumerator() {
+      return this.data.GetEnumerator();
+    }
+
+    public T ElementAt(int index) {
+      return this.data[index];
+    }
+
+    public T ReverseElementAt(int offset) {
+      return this.data[this.data.Count - 1 - offset];
+    }
+
+    public void SetTop(T value) {
+      this.data[this.Count - 1] = value;
+    }
+
+    public T this[int key]
+    {
+      get
+      {
+        return this.data[key];
+      }
+      set
+      {
+        this.data[key] = value;
+      }
+    }
+
+    public void Swap(int count) {
+      var top = this.Top;
+      var bottomIndex = this.Count - count;
+
+      for (var i = this.Count - 1; i > bottomIndex; i--) this.data[i] = this.data[i - 1];
+
+      this.data[bottomIndex] = top;
+    }
+
+    public void Yank(int index) {
+      if (index == this.Count - 1) return;
+
+      var item = this.ElementAt(index);
+      this.data.RemoveAt(index);
+      this.data.Add(item);
+    }
+
+    public T Pop() {
+      var value = this.data[this.Count - 1];
+      this.data.RemoveAt(this.Count - 1);
+
+      return value;
+    }
+
+    public T[] Pop(int count) {
+      var items = this.Peek(count);
+      this.Remove(count);
+
+      return items;
+    }
+
+    public T Peek() {
+      return this.Top;
+    }
+
+    public T[] Peek(int count) {
+      var startIndex = this.Count - count;
+
+      var items = new T[count];
+      this.data.CopyTo(startIndex, items, 0, count);
+
+      return items;
+    }
+
+    public void Push(T item) {
+      if (!this.IsEnabled) return;
+
+      this.data.Add(item);
+    }
+
+    public void Push(T item1, T item2) {
+      if (!this.IsEnabled) return;
+
+      this.data.Add(item1);
+      this.data.Add(item2);
+    }
+
+    public void Push(T item1, T item2, T item3) {
+      if (!this.IsEnabled) return;
+
+      this.data.Add(item1);
+      this.data.Add(item2);
+      this.data.Add(item3);
+    }
+
+    public void Push(T item1, T item2, T item3, T item4) {
+      if (!this.IsEnabled) return;
+
+      this.data.Add(item1);
+      this.data.Add(item2);
+      this.data.Add(item3);
+      this.data.Add(item4);
+    }
+
+    public void PushResult(int count, Func<T[], T> templateFunc) {
+      if (!this.IsEnabled) return;
+
+      var startIndex = this.Count - count;
+      var items = new T[count];
+
+      this.data.CopyTo(startIndex, items, 0, count);
+      this.Remove(count - 1);
+
+      this.data[this.Count - 1] = templateFunc(items);
+    }
+
+    public void Push(IReadOnlyList<T> items) {
+      if (!this.IsEnabled) return;
+
+      for (var i = 0; i < items.Count; i++) this.data.Add(items[i]);
+    }
+
+    public void Insert(int index, T item) {
+      if (!this.IsEnabled) return;
+
+      this.data.Insert(index, item);
+    }
+
+    public void Insert(int index, params T[] items) {
+      if (!this.IsEnabled) return;
+
+      this.data.InsertRange(index, items);
+    }
+
+    public void Insert(int index, IEnumerable<T> items) {
+      if (!this.IsEnabled) return;
+
+      this.data.InsertRange(index, items);
+    }
+
+    public bool Remove(T item) {
+      var index = this.Count - 1;
+      if ((this.Count > 0) && this.data[index].Equals(item)) {
+        this.data.RemoveAt(index);
+        return true;
+      }
+      return false;
+    }
+
+    public void RemoveTop() {
+      this.data.RemoveAt(this.Count - 1);
+    }
+
+    public void Remove(int count) {
+      for (var i = 0; i < count; i++) this.data.RemoveAt(this.Count - 1);
+    }
+
+    public void RemoveAt(int index) {
+      this.data.RemoveAt(index);
+    }
+
+    public void RemoveAt(int index, int count) {
+      this.data.RemoveRange(index, count);
+    }
+
+    public bool TryPop(out T item) {
+      if (this.Count > 0) {
+        item = this.Pop();
+        return true;
+      }
+      item = default(T);
+      return false;
+    }
+
+    public override string ToString() {
+      var data = this.data as IEnumerable<T>;
+      return string.Join(Delimiter, data.Reverse());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack3.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack3.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/DirtyList/PushStack3.cs	(revision 14777)
@@ -0,0 +1,286 @@
+﻿namespace TestPooling.DirtyList {
+  using System;
+  using System.Collections.Generic;
+  using System.Linq;
+
+  /// <summary>
+  ///     While Push's stacks are generally treated as genuine stacks---that is, inclassions take their arguments from the
+  ///     tops of
+  ///     the stacks and push their results onto the tops of the stacks---a few inclassions (like YANK and SHOVE) do allow
+  ///     direct access
+  ///     to "deep" stack elements by means of integer indices. To this extent the stacks can be used as general, random
+  ///     access memory
+  ///     classures. This is one of the features that ensures the Turing-completeness of Push (another being the arbitrary
+  ///     name/value
+  ///     bindings supported by the NAME data type and DEFINE methods; see below).
+  /// </summary>
+  /// <typeparam name="T">The item type of the collection.</typeparam>
+  public class PushStack3<T> {
+    private const string Delimiter = " ";
+
+    private readonly LinkedList<T> data;
+
+    public PushStack3() {
+      this.data = new LinkedList<T>();
+      this.IsEnabled = true;
+    }
+
+    public bool IsEnabled { get; set; }
+
+    public T Top
+    {
+      get
+      {
+        return this.data.Last.Value;
+      }
+    }
+
+    public T TopOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? Top : default(T);
+      }
+    }
+
+    public T Bottom
+    {
+      get
+      {
+        return this.data.First.Value;
+      }
+    }
+
+    public T BottomOrDefault
+    {
+      get
+      {
+        return this.Count > 0 ? Bottom : default(T);
+      }
+    }
+
+    public int Count
+    {
+      get
+      {
+        return this.data.Count;
+      }
+    }
+
+    public bool IsEmpty
+    {
+      get
+      {
+        return this.Count == 0;
+      }
+    }
+
+    public bool IsReadOnly
+    {
+      get
+      {
+        return false;
+      }
+    }
+
+    public void Add(T item) {
+      this.Push(item);
+    }
+
+    public void Clear() {
+      this.data.Clear();
+    }
+
+    public bool Contains(T item) {
+      return this.data.Contains(item);
+    }
+
+    public void CopyTo(T[] array, int arrayIndex) {
+      this.data.CopyTo(array, arrayIndex);
+    }
+
+    public IEnumerator<T> GetEnumerator() {
+      return this.data.GetEnumerator();
+    }
+
+    public T ElementAt(int index) {
+      return this.data.ElementAt(index);
+    }
+
+    public T ReverseElementAt(int offset) {
+      return ElementAt(Count - 1 - offset);
+    }
+
+    public void SetTop(T value) {
+      this.data.Last.Value = value;
+    }
+
+    private LinkedListNode<T> GetByIndex(int index) {
+      var current = data.First;
+      for (var i = 0; i <= index; i++) {
+        current = current.Next;
+      }
+
+      return current;
+    }
+
+    public T this[int key]
+    {
+      get
+      {
+        return ElementAt(key);
+      }
+      set
+      {
+        GetByIndex(key).Value = value;
+      }
+    }
+
+    public void Swap(int count) {
+      var topValue = this.Top;
+      var current = this.data.Last;
+      var bottomIndex = this.Count - count;
+
+
+      for (var i = this.Count - 1; i > bottomIndex; i--) {
+        current.Value = current.Previous.Value;
+        current = current.Previous;
+      }
+
+      this.data.Last.Value = topValue;
+    }
+
+    public void Yank(int index) {
+      if (index == this.Count - 1) return;
+
+      var item = this.GetByIndex(index);
+      this.data.Remove(item);
+      this.data.AddLast(item);
+    }
+
+    public T Pop() {
+      var value = Top;
+      this.data.RemoveLast();
+
+      return value;
+    }
+
+    public T[] Pop(int count) {
+      var items = new T[count];
+
+      for (var i = 0; i < count; i++) {
+        items[count - i] = Top;
+        data.RemoveLast();
+      }
+
+      return items;
+    }
+
+    public T Peek() {
+      return this.Top;
+    }
+
+    public T[] Peek(int count) {
+      var items = new T[count];
+      var current = this.data.Last;
+
+      for (var i = 0; i < count; i++) {
+        items[count - i] = current.Value;
+        current = current.Previous;
+      }
+
+      return items;
+    }
+
+    public void Push(T item) {
+      if (!this.IsEnabled) return;
+
+      this.data.AddLast(item);
+    }
+
+    public void Push(T item1, T item2) {
+      if (!this.IsEnabled) return;
+
+      this.data.AddLast(item1);
+      this.data.AddLast(item2);
+    }
+
+    public void Push(T item1, T item2, T item3) {
+      if (!this.IsEnabled) return;
+
+      this.data.AddLast(item1);
+      this.data.AddLast(item2);
+      this.data.AddLast(item3);
+    }
+
+    public void Push(T item1, T item2, T item3, T item4) {
+      if (!this.IsEnabled) return;
+
+      this.data.AddLast(item1);
+      this.data.AddLast(item2);
+      this.data.AddLast(item3);
+      this.data.AddLast(item4);
+    }
+
+    public void PushResult(int count, Func<T[], T> templateFunc) {
+      if (!this.IsEnabled) return;
+
+      Push(templateFunc(Pop(count)));
+    }
+
+    public void PushRange(IReadOnlyList<T> items) {
+      if (!this.IsEnabled) return;
+
+      for (var i = 0; i < items.Count; i++) this.data.AddLast(items[i]);
+    }
+
+    public void Insert(int index, T value) {
+      if (!this.IsEnabled) return;
+
+      var node = GetByIndex(index);
+      this.data.AddBefore(node, value);
+    }
+
+    public bool Remove(T item) {
+      return this.data.Remove(item);
+    }
+
+    public void RemoveTop() {
+      this.data.RemoveLast();
+    }
+
+    public void Remove(int count) {
+      for (var i = 0; i < count; i++) this.data.RemoveLast();
+    }
+
+    public void RemoveAt(int index) {
+      var node = GetByIndex(index);
+
+      this.data.Remove(node);
+    }
+
+    public void RemoveAt(int index, int count) {
+
+      var node = GetByIndex(index);
+
+      for (var i = 0; i < count; i++) {
+        data.Remove(node);
+        node = node.Next;
+      }
+    }
+
+    public bool TryPop(out T item) {
+      if (this.Count > 0) {
+        item = this.Pop();
+        return true;
+      }
+      item = default(T);
+      return false;
+    }
+
+    public override string ToString() {
+      var data = this.data as IEnumerable<T>;
+      return string.Join(Delimiter, data.Reverse());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/FeatureTests.csproj
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/FeatureTests.csproj	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/FeatureTests.csproj	(revision 14777)
@@ -0,0 +1,84 @@
+﻿<?xml version="1.0" encoding="utf-8"?>
+<Project ToolsVersion="14.0" DefaultTargets="Build" xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
+  <Import Project="$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props" Condition="Exists('$(MSBuildExtensionsPath)\$(MSBuildToolsVersion)\Microsoft.Common.props')" />
+  <PropertyGroup>
+    <Configuration Condition=" '$(Configuration)' == '' ">Debug</Configuration>
+    <Platform Condition=" '$(Platform)' == '' ">AnyCPU</Platform>
+    <ProjectGuid>{B184A849-1403-4F5F-96F8-952C6599A7C0}</ProjectGuid>
+    <OutputType>Exe</OutputType>
+    <AppDesignerFolder>Properties</AppDesignerFolder>
+    <RootNamespace>TestPooling</RootNamespace>
+    <AssemblyName>TestPooling</AssemblyName>
+    <TargetFrameworkVersion>v4.5.2</TargetFrameworkVersion>
+    <FileAlignment>512</FileAlignment>
+    <AutoGenerateBindingRedirects>true</AutoGenerateBindingRedirects>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Debug|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugSymbols>true</DebugSymbols>
+    <DebugType>full</DebugType>
+    <Optimize>false</Optimize>
+    <OutputPath>bin\Debug\</OutputPath>
+    <DefineConstants>DEBUG;TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
+    <PlatformTarget>AnyCPU</PlatformTarget>
+    <DebugType>pdbonly</DebugType>
+    <Optimize>true</Optimize>
+    <OutputPath>bin\Release\</OutputPath>
+    <DefineConstants>TRACE</DefineConstants>
+    <ErrorReport>prompt</ErrorReport>
+    <WarningLevel>4</WarningLevel>
+  </PropertyGroup>
+  <ItemGroup>
+    <Reference Include="HeuristicLab.Common-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Common-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Core-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Core-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="HeuristicLab.Random-3.3">
+      <HintPath>..\..\..\..\trunk\sources\bin\HeuristicLab.Random-3.3.dll</HintPath>
+    </Reference>
+    <Reference Include="System" />
+    <Reference Include="System.Core" />
+    <Reference Include="System.Xml.Linq" />
+    <Reference Include="System.Data.DataSetExtensions" />
+    <Reference Include="Microsoft.CSharp" />
+    <Reference Include="System.Data" />
+    <Reference Include="System.Net.Http" />
+    <Reference Include="System.Xml" />
+  </ItemGroup>
+  <ItemGroup>
+    <Compile Include="DirtyList\DirtyList.cs" />
+    <Compile Include="DirtyList\PushList.cs" />
+    <Compile Include="DirtyList\PushStack3.cs" />
+    <Compile Include="DirtyList\PushStack.cs" />
+    <Compile Include="Pool\IPooledObject.cs" />
+    <Compile Include="Pool\ManagedPool.cs" />
+    <Compile Include="Pool\ManagedPoolProvider.cs" />
+    <Compile Include="Pool\ObjectPool.cs" />
+    <Compile Include="Pool\PooledList.cs" />
+    <Compile Include="Program.cs" />
+    <Compile Include="Properties\AssemblyInfo.cs" />
+  </ItemGroup>
+  <ItemGroup>
+    <None Include="App.config" />
+  </ItemGroup>
+  <ItemGroup>
+    <ProjectReference Include="..\HeuristicLab.Problems.ProgramSynthesis\HeuristicLab.Problems.ProgramSynthesis.csproj">
+      <Project>{5C93448C-47E3-4C3F-B1D0-EE62A48C3204}</Project>
+      <Name>HeuristicLab.Problems.ProgramSynthesis</Name>
+    </ProjectReference>
+  </ItemGroup>
+  <Import Project="$(MSBuildToolsPath)\Microsoft.CSharp.targets" />
+  <!-- To modify your build process, add your task inside one of the targets below and uncomment it. 
+       Other similar extension points exist, see Microsoft.Common.targets.
+  <Target Name="BeforeBuild">
+  </Target>
+  <Target Name="AfterBuild">
+  </Target>
+  -->
+</Project>
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/IPooledObject.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/IPooledObject.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/IPooledObject.cs	(revision 14777)
@@ -0,0 +1,13 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace TestPooling.Pool
+{
+    public interface IPooledObject
+    {
+      void Reset();
+    }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPool.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPool.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPool.cs	(revision 14777)
@@ -0,0 +1,61 @@
+﻿using System.Collections.Generic;
+
+namespace TestPooling.Pool {
+  using System;
+  using System.Collections.Concurrent;
+  using System.Linq;
+
+  public class ManagedPool<T> : IDisposable where T : class, IPooledObject {
+
+    private static readonly ConcurrentStack<LinkedList<T>> Pool = new ConcurrentStack<LinkedList<T>>();
+    private readonly Func<T> Factory;
+    public readonly int PartitionSize;
+
+    private readonly IList<LinkedList<T>> partitions = new List<LinkedList<T>>();
+    private LinkedList<T> currentPartition;
+    private LinkedListNode<T> currentNode;
+
+    private int entryIndex = 0;
+
+    public static int InstanceCount { get { return Pool.Sum(p => p.Count); } }
+
+    public ManagedPool(int partitionSize, Func<T> factory) {
+      PartitionSize = partitionSize;
+      Factory = factory;
+    }
+
+    public T Get() {
+      if (currentPartition == null || entryIndex == PartitionSize) {
+        currentPartition = GetPartition();
+        currentNode = currentPartition.First;
+        entryIndex = 0;
+
+        partitions.Add(currentPartition);
+      }
+
+      T entry;
+      if (currentNode == null) {
+        entry = Factory();
+        currentPartition.AddLast(entry);
+      } else {
+        entry = currentNode.Value;
+        currentNode = currentNode.Next;
+      }
+
+      entryIndex++;
+      entry.Reset();
+
+      return entry;
+    }
+
+    private LinkedList<T> GetPartition() {
+      LinkedList<T> partition;
+
+      return Pool.TryPop(out partition) ? partition : new LinkedList<T>();
+    }
+
+    public void Dispose() {
+      Pool.PushRange(partitions.ToArray());
+    }
+  }
+}
Index: branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPoolProvider.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPoolProvider.cs	(revision 14777)
+++ branches/PushGP/HeuristicLab.PushGP/FeatureTests/Pool/ManagedPoolProvider.cs	(revision 14777)
@@ -0,0 +1,102 @@
+﻿namespace TestPooling.Pool {
+  using System;
+  using System.Collections.Concurrent;
+  using System.Collections.Generic;
+  using System.IO;
+  using System.Linq;
+  using System.Runtime.Serialization.Formatters.Binary;
+
+  public interface IManagedPool<T> : IDisposable where T : class, IPooledObject {
+    T Get();
+  }
+
+  public class ManagedPoolProvider<T> where T : class, IPooledObject {
+    private readonly ConcurrentStack<T[]> partitions = new ConcurrentStack<T[]>();
+    private readonly ObjectPool<IManagedPool<T>> managedPools;
+    private readonly BinaryFormatter binaryFormatter = new BinaryFormatter();
+    private byte[] dummyPartition;
+
+    public readonly int PartitionSize;
+    public readonly int MaxParitionCount;
+    public const int DefaultMaxInstanceCount = 65536;
+
+    public ManagedPoolProvider(int partitionSize, Func<T> factory, int? maxPartitionCount = null) {
+      PartitionSize = partitionSize;
+      MaxParitionCount = maxPartitionCount ?? DefaultMaxInstanceCount / PartitionSize;
+
+      managedPools = new ObjectPool<IManagedPool<T>>(() => new ManagedPool<T>(this));
+
+      InitDummyPartition(factory);
+    }
+
+    private void InitDummyPartition(Func<T> factory) {
+      var temp = new T[PartitionSize];
+
+      for (var i = 0; i < PartitionSize; i++) {
+        temp[i] = factory();
+      }
+
+      using (var memoryStream = new MemoryStream()) {
+        binaryFormatter.Serialize(memoryStream, temp);
+        dummyPartition = memoryStream.ToArray();
+      }
+    }
+
+    public int InstanceCount { get { return partitions.Count * PartitionSize; } }
+
+    public void ReleasePartitions(params T[][] partition) {
+      if (partitions.Count <= MaxParitionCount && partition.Length > 0)
+        partitions.PushRange(partition);
+    }
+
+    private T[] GetPartition() {
+      T[] partition;
+      return partitions.TryPop(out partition) ? partition : CloneDummyPartition();
+    }
+
+    private T[] CloneDummyPartition() {
+      using (var memoryStream = new MemoryStream(dummyPartition)) {
+        memoryStream.Seek(0, SeekOrigin.Begin);
+
+        return (T[])binaryFormatter.Deserialize(memoryStream);
+      }
+    }
+
+    public IManagedPool<T> CreatePool() {
+      return managedPools.Allocate();
+    }
+
+    private class ManagedPool<T> : IManagedPool<T> where T : class, IPooledObject {
+      private readonly ManagedPoolProvider<T> provider;
+      private readonly IList<T[]> partitions = new List<T[]>();
+      private T[] currentPartition;
+      private int entryIndex;
+
+      public ManagedPool(ManagedPoolProvider<T> provider) {
+        this.provider = provider;
+        entryIndex = provider.PartitionSize;
+      }
+
+      public T Get() {
+        if (entryIndex == provider.PartitionSize) {
+          currentPartition = provider.GetPartition();
+          partitions.Add(currentPartition);
+          entryIndex = 0;
+        }
+
+        var entry = currentPartition[entryIndex++];
+
+        entry.Reset();
+
+        return entry;
+      }
+
+      public void Dispose() {
+        provider.ReleasePartitions(partitions.ToArray());
+        partitions.Clear();
+        entryIndex = provider.PartitionSize;
+        provider.managedPools.Free(this);
+      }
+    }
+  }
+}
